<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="活动名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入活动名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="活动类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择卡券类型" @keyup.enter.native="handleQuery">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.MEMBER_ACTIVE)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined)"
                   v-hasPermi="['member:active-main:create']">新增
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="活动名称" align="center" prop="name"/>
      <el-table-column label="活动类型" align="center" prop="type">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.MEMBER_ACTIVE" :value="scope.row.type"/>
        </template>
      </el-table-column>
      <el-table-column label="活动开始时间" align="center" prop="beginTime" width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.beginTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="活动结束时间" align="center" prop="endTime" width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.endTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="活动状态" align="center" prop="status">
        <template v-slot="scope">
          <el-tag v-if="scope.row.status == '01'" type="success">启用</el-tag>
          <el-tag v-if="scope.row.status == '02'" type="danger">停用</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="活动描述" show-overflow-tooltip align="center" prop="remark"/>

      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button v-if="scope.row.isCoupon == '1'" size="mini" type="text" icon="el-icon-bank-card" @click="openCouponForm(scope.row.id)"
                     v-hasPermi="['member:active-main:update']">关联卡券
          </el-button>
          <el-button v-if="scope.row.isRechRule == '1'"  size="mini" type="text" icon="el-icon-wallet" @click="openRuleForm(scope.row.id)"
                     v-hasPermi="['member:active-main:update']">充值规则
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id)"
                     v-hasPermi="['member:active-main:update']">修改
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['member:active-main:delete']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
    <!-- 对话框(添加 / 修改) -->
    <ActiveMainForm ref="formRef" @success="getList"/>
    <!--  充值规则  -->
    <ActiveRuleForm ref="ruleFormRef" @success="getList"/>
    <!--  关联卡券  -->
    <ActiveRuleCouponForm ref="couponFormRef" @success="getList"/>
  </div>
</template>

<script>
import * as ActiveMainApi from '@/api/member/active';
import ActiveMainForm from './ActiveMainForm.vue';
import ActiveRuleForm from './ActiveRuleForm.vue';
import ActiveRuleCouponForm from './ActiveRuleCouponForm.vue';

export default {
  name: "ActiveMain",
  components: {
    ActiveMainForm,ActiveRuleForm,ActiveRuleCouponForm
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 营销活动列表
      list: [],
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        name: null,
        type: null,
        beginTime: [],
        endTime: [],
        status: null,
        remark: null,
        isMember: null,
        createTime: [],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true;
        const res = await ActiveMainApi.getActiveMainPage(this.queryParams);
        this.list = res.data.records;
        this.total = res.data.total;
      } finally {
        this.loading = false;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 添加/修改操作 */
    openForm(id) {
      this.$refs["formRef"].open(id);
    },
    /** 添加规则 */
    openRuleForm(id) {
      this.$refs["ruleFormRef"].open(id);
    },
    /** 添加规则 */
    openCouponForm(id) {
      this.$refs["couponFormRef"].open(id);
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除营销活动名称为"' + row.name + '"的数据项?')
      try {
        await ActiveMainApi.deleteActiveMain(id);
        await this.getList();
        this.$modal.msgSuccess("删除成功");
      } catch {
      }
    },
    /** 导出按钮操作 */
    async handleExport() {
      await this.$modal.confirm('是否确认导出所有营销活动数据项?');
      try {
        this.exportLoading = true;
        const data = await ActiveMainApi.exportActiveMainExcel(this.queryParams);
        this.$download.excel(data, '营销活动.xls');
      } catch {
      } finally {
        this.exportLoading = false;
      }
    },
  }
};
</script>
